// content/public/common/trust_tokens.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_TRUST_TOKENS_MOJOM_H_
#define CONTENT_PUBLIC_COMMON_TRUST_TOKENS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "content/public/common/trust_tokens.mojom-shared.h"
#include "content/public/common/trust_tokens.mojom-forward.h"
#include "services/network/public/mojom/trust_tokens.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace content {
namespace mojom {

class LocalTrustTokenFulfillerProxy;

template <typename ImplRefTraits>
class LocalTrustTokenFulfillerStub;

class LocalTrustTokenFulfillerRequestValidator;
class LocalTrustTokenFulfillerResponseValidator;


class  LocalTrustTokenFulfiller
    : public LocalTrustTokenFulfillerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = LocalTrustTokenFulfillerInterfaceBase;
  using Proxy_ = LocalTrustTokenFulfillerProxy;

  template <typename ImplRefTraits>
  using Stub_ = LocalTrustTokenFulfillerStub<ImplRefTraits>;

  using RequestValidator_ = LocalTrustTokenFulfillerRequestValidator;
  using ResponseValidator_ = LocalTrustTokenFulfillerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kFulfillTrustTokenIssuanceMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct FulfillTrustTokenIssuance_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~LocalTrustTokenFulfiller() = default;


  using FulfillTrustTokenIssuanceCallback = base::OnceCallback<void(::network::mojom::FulfillTrustTokenIssuanceAnswerPtr)>;
  
  virtual void FulfillTrustTokenIssuance(::network::mojom::FulfillTrustTokenIssuanceRequestPtr request, FulfillTrustTokenIssuanceCallback callback) = 0;
};



class  LocalTrustTokenFulfillerProxy
    : public LocalTrustTokenFulfiller {
 public:
  using InterfaceType = LocalTrustTokenFulfiller;

  explicit LocalTrustTokenFulfillerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void FulfillTrustTokenIssuance(::network::mojom::FulfillTrustTokenIssuanceRequestPtr request, FulfillTrustTokenIssuanceCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  LocalTrustTokenFulfillerStubDispatch {
 public:
  static bool Accept(LocalTrustTokenFulfiller* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LocalTrustTokenFulfiller* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LocalTrustTokenFulfiller>>
class LocalTrustTokenFulfillerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LocalTrustTokenFulfillerStub() = default;
  ~LocalTrustTokenFulfillerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LocalTrustTokenFulfillerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LocalTrustTokenFulfillerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LocalTrustTokenFulfillerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LocalTrustTokenFulfillerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#endif  // CONTENT_PUBLIC_COMMON_TRUST_TOKENS_MOJOM_H_