// extensions/common/mojom/automation_query.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJOM_AUTOMATION_QUERY_MOJOM_H_
#define EXTENSIONS_COMMON_MOJOM_AUTOMATION_QUERY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "extensions/common/mojom/automation_query.mojom-shared.h"
#include "extensions/common/mojom/automation_query.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace extensions {
namespace mojom {

class AutomationQueryProxy;

template <typename ImplRefTraits>
class AutomationQueryStub;

class AutomationQueryRequestValidator;
class AutomationQueryResponseValidator;


class  AutomationQuery
    : public AutomationQueryInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AutomationQueryInterfaceBase;
  using Proxy_ = AutomationQueryProxy;

  template <typename ImplRefTraits>
  using Stub_ = AutomationQueryStub<ImplRefTraits>;

  using RequestValidator_ = AutomationQueryRequestValidator;
  using ResponseValidator_ = AutomationQueryResponseValidator;
  enum MethodMinVersions : uint32_t {
    kQuerySelectorMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct QuerySelector_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AutomationQuery() = default;


  using QuerySelectorCallback = base::OnceCallback<void(int32_t, AutomationQueryError)>;
  
  virtual void QuerySelector(int32_t acc_obj_id, const std::string& selector, QuerySelectorCallback callback) = 0;
};



class  AutomationQueryProxy
    : public AutomationQuery {
 public:
  using InterfaceType = AutomationQuery;

  explicit AutomationQueryProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void QuerySelector(int32_t acc_obj_id, const std::string& selector, QuerySelectorCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  AutomationQueryStubDispatch {
 public:
  static bool Accept(AutomationQuery* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AutomationQuery* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AutomationQuery>>
class AutomationQueryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AutomationQueryStub() = default;
  ~AutomationQueryStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AutomationQueryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AutomationQueryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  AutomationQueryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  AutomationQueryResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace extensions

namespace mojo {

}  // namespace mojo

#endif  // EXTENSIONS_COMMON_MOJOM_AUTOMATION_QUERY_MOJOM_H_