// services/network/public/mojom/client_security_state.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_CLIENT_SECURITY_STATE_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_CLIENT_SECURITY_STATE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/client_security_state.mojom-shared.h"
#include "services/network/public/mojom/client_security_state.mojom-blink-forward.h"
#include "services/network/public/mojom/cross_origin_embedder_policy.mojom-blink.h"
#include "services/network/public/mojom/ip_address_space.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
struct network_mojom_internal_PrivateNetworkRequestPolicy_DataHashFn {
  static unsigned GetHash(const ::network::mojom::PrivateNetworkRequestPolicy& value) {
    using utype = std::underlying_type<::network::mojom::PrivateNetworkRequestPolicy>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::network::mojom::PrivateNetworkRequestPolicy& left, const ::network::mojom::PrivateNetworkRequestPolicy& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::network::mojom::PrivateNetworkRequestPolicy>
    : public GenericHashTraits<::network::mojom::PrivateNetworkRequestPolicy> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool kEmptyValueIsZero = false;
  static ::network::mojom::PrivateNetworkRequestPolicy EmptyValue() { return static_cast<::network::mojom::PrivateNetworkRequestPolicy>(-1000000); }
  static void ConstructDeletedValue(::network::mojom::PrivateNetworkRequestPolicy& slot, bool) {
    slot = static_cast<::network::mojom::PrivateNetworkRequestPolicy>(-1000001);
  }
  static bool IsDeletedValue(const ::network::mojom::PrivateNetworkRequestPolicy& value) {
    return value == static_cast<::network::mojom::PrivateNetworkRequestPolicy>(-1000001);
  }
};
}  // namespace WTF


namespace network {
namespace mojom {
namespace blink {








class BLINK_PLATFORM_EXPORT ClientSecurityState {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ClientSecurityState, T>::value>;
  using DataView = ClientSecurityStateDataView;
  using Data_ = internal::ClientSecurityState_Data;

  template <typename... Args>
  static ClientSecurityStatePtr New(Args&&... args) {
    return ClientSecurityStatePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ClientSecurityStatePtr From(const U& u) {
    return mojo::TypeConverter<ClientSecurityStatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ClientSecurityState>::Convert(*this);
  }


  ClientSecurityState();

  ClientSecurityState(
      const ::network::CrossOriginEmbedderPolicy& cross_origin_embedder_policy,
      bool is_web_secure_context,
      ::network::mojom::blink::IPAddressSpace ip_address_space,
      PrivateNetworkRequestPolicy private_network_request_policy);


  ~ClientSecurityState();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ClientSecurityStatePtr>
  ClientSecurityStatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ClientSecurityState::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ClientSecurityState::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ClientSecurityState_UnserializedMessageContext<
            UserType, ClientSecurityState::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ClientSecurityState::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ClientSecurityState::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ClientSecurityState_UnserializedMessageContext<
            UserType, ClientSecurityState::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ClientSecurityState::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::network::CrossOriginEmbedderPolicy cross_origin_embedder_policy;
  
  bool is_web_secure_context;
  
  ::network::mojom::blink::IPAddressSpace ip_address_space;
  
  PrivateNetworkRequestPolicy private_network_request_policy;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ClientSecurityState::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ClientSecurityStatePtr ClientSecurityState::Clone() const {
  return New(
      mojo::Clone(cross_origin_embedder_policy),
      mojo::Clone(is_web_secure_context),
      mojo::Clone(ip_address_space),
      mojo::Clone(private_network_request_policy)
  );
}

template <typename T, ClientSecurityState::EnableIfSame<T>*>
bool ClientSecurityState::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->cross_origin_embedder_policy, other_struct.cross_origin_embedder_policy))
    return false;
  if (!mojo::Equals(this->is_web_secure_context, other_struct.is_web_secure_context))
    return false;
  if (!mojo::Equals(this->ip_address_space, other_struct.ip_address_space))
    return false;
  if (!mojo::Equals(this->private_network_request_policy, other_struct.private_network_request_policy))
    return false;
  return true;
}

template <typename T, ClientSecurityState::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.cross_origin_embedder_policy < rhs.cross_origin_embedder_policy)
    return true;
  if (rhs.cross_origin_embedder_policy < lhs.cross_origin_embedder_policy)
    return false;
  if (lhs.is_web_secure_context < rhs.is_web_secure_context)
    return true;
  if (rhs.is_web_secure_context < lhs.is_web_secure_context)
    return false;
  if (lhs.ip_address_space < rhs.ip_address_space)
    return true;
  if (rhs.ip_address_space < lhs.ip_address_space)
    return false;
  if (lhs.private_network_request_policy < rhs.private_network_request_policy)
    return true;
  if (rhs.private_network_request_policy < lhs.private_network_request_policy)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::ClientSecurityState::DataView,
                                         ::network::mojom::blink::ClientSecurityStatePtr> {
  static bool IsNull(const ::network::mojom::blink::ClientSecurityStatePtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ClientSecurityStatePtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::ClientSecurityState::cross_origin_embedder_policy)& cross_origin_embedder_policy(
      const ::network::mojom::blink::ClientSecurityStatePtr& input) {
    return input->cross_origin_embedder_policy;
  }

  static decltype(::network::mojom::blink::ClientSecurityState::is_web_secure_context) is_web_secure_context(
      const ::network::mojom::blink::ClientSecurityStatePtr& input) {
    return input->is_web_secure_context;
  }

  static decltype(::network::mojom::blink::ClientSecurityState::ip_address_space) ip_address_space(
      const ::network::mojom::blink::ClientSecurityStatePtr& input) {
    return input->ip_address_space;
  }

  static decltype(::network::mojom::blink::ClientSecurityState::private_network_request_policy) private_network_request_policy(
      const ::network::mojom::blink::ClientSecurityStatePtr& input) {
    return input->private_network_request_policy;
  }

  static bool Read(::network::mojom::blink::ClientSecurityState::DataView input, ::network::mojom::blink::ClientSecurityStatePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_CLIENT_SECURITY_STATE_MOJOM_BLINK_H_