// third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FENCED_FRAME_FENCED_FRAME_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FENCED_FRAME_FENCED_FRAME_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom-shared.h"
#include "third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class FencedFrameOwnerHostProxy;

template <typename ImplRefTraits>
class FencedFrameOwnerHostStub;

class FencedFrameOwnerHostRequestValidator;


class BLINK_COMMON_EXPORT FencedFrameOwnerHost
    : public FencedFrameOwnerHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FencedFrameOwnerHostInterfaceBase;
  using Proxy_ = FencedFrameOwnerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = FencedFrameOwnerHostStub<ImplRefTraits>;

  using RequestValidator_ = FencedFrameOwnerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kNavigateMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Navigate_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FencedFrameOwnerHost() = default;

  
  virtual void Navigate(const ::GURL& url, ::base::TimeTicks navigation_start_time) = 0;
};



class BLINK_COMMON_EXPORT FencedFrameOwnerHostProxy
    : public FencedFrameOwnerHost {
 public:
  using InterfaceType = FencedFrameOwnerHost;

  explicit FencedFrameOwnerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Navigate(const ::GURL& url, ::base::TimeTicks navigation_start_time) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FencedFrameOwnerHostStubDispatch {
 public:
  static bool Accept(FencedFrameOwnerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FencedFrameOwnerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FencedFrameOwnerHost>>
class FencedFrameOwnerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FencedFrameOwnerHostStub() = default;
  ~FencedFrameOwnerHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FencedFrameOwnerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FencedFrameOwnerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FencedFrameOwnerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT FencedFrameReporting {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FencedFrameReporting, T>::value>;
  using DataView = FencedFrameReportingDataView;
  using Data_ = internal::FencedFrameReporting_Data;

  template <typename... Args>
  static FencedFrameReportingPtr New(Args&&... args) {
    return FencedFrameReportingPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FencedFrameReportingPtr From(const U& u) {
    return mojo::TypeConverter<FencedFrameReportingPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FencedFrameReporting>::Convert(*this);
  }


  FencedFrameReporting();

  explicit FencedFrameReporting(
      const base::flat_map<ReportingDestination, base::flat_map<std::string, ::GURL>>& metadata);


  ~FencedFrameReporting();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FencedFrameReportingPtr>
  FencedFrameReportingPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FencedFrameReporting::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FencedFrameReporting::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FencedFrameReporting_UnserializedMessageContext<
            UserType, FencedFrameReporting::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FencedFrameReporting::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FencedFrameReporting::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FencedFrameReporting_UnserializedMessageContext<
            UserType, FencedFrameReporting::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FencedFrameReporting::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  base::flat_map<ReportingDestination, base::flat_map<std::string, ::GURL>> metadata;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FencedFrameReporting::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FencedFrameReportingPtr FencedFrameReporting::Clone() const {
  return New(
      mojo::Clone(metadata)
  );
}

template <typename T, FencedFrameReporting::EnableIfSame<T>*>
bool FencedFrameReporting::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->metadata, other_struct.metadata))
    return false;
  return true;
}

template <typename T, FencedFrameReporting::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.metadata < rhs.metadata)
    return true;
  if (rhs.metadata < lhs.metadata)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::FencedFrameReporting::DataView,
                                         ::blink::mojom::FencedFrameReportingPtr> {
  static bool IsNull(const ::blink::mojom::FencedFrameReportingPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::FencedFrameReportingPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::FencedFrameReporting::metadata)& metadata(
      const ::blink::mojom::FencedFrameReportingPtr& input) {
    return input->metadata;
  }

  static bool Read(::blink::mojom::FencedFrameReporting::DataView input, ::blink::mojom::FencedFrameReportingPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FENCED_FRAME_FENCED_FRAME_MOJOM_H_