// third_party/blink/public/mojom/interest_group/ad_auction_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-shared.h"
#include "third_party/blink/public/mojom/interest_group/ad_auction_service.mojom-forward.h"
#include "third_party/blink/public/mojom/parakeet/ad_request.mojom-forward.h"
#include "third_party/blink/public/mojom/interest_group/interest_group_types.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class AbortableAdAuctionProxy;

template <typename ImplRefTraits>
class AbortableAdAuctionStub;

class AbortableAdAuctionRequestValidator;


class BLINK_COMMON_EXPORT AbortableAdAuction
    : public AbortableAdAuctionInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AbortableAdAuctionInterfaceBase;
  using Proxy_ = AbortableAdAuctionProxy;

  template <typename ImplRefTraits>
  using Stub_ = AbortableAdAuctionStub<ImplRefTraits>;

  using RequestValidator_ = AbortableAdAuctionRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kAbortMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Abort_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AbortableAdAuction() = default;

  
  virtual void Abort() = 0;
};

class AdAuctionServiceProxy;

template <typename ImplRefTraits>
class AdAuctionServiceStub;

class AdAuctionServiceRequestValidator;
class AdAuctionServiceResponseValidator;


class BLINK_COMMON_EXPORT AdAuctionService
    : public AdAuctionServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AdAuctionServiceInterfaceBase;
  using Proxy_ = AdAuctionServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = AdAuctionServiceStub<ImplRefTraits>;

  using RequestValidator_ = AdAuctionServiceRequestValidator;
  using ResponseValidator_ = AdAuctionServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateAdRequestMinVersion = 0,
    kFinalizeAdMinVersion = 0,
    kRunAdAuctionMinVersion = 0,
    kJoinInterestGroupMinVersion = 0,
    kLeaveInterestGroupMinVersion = 0,
    kLeaveInterestGroupForDocumentMinVersion = 0,
    kUpdateAdInterestGroupsMinVersion = 0,
    kDeprecatedGetURLFromURNMinVersion = 0,
    kDeprecatedReplaceInURNMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateAdRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct FinalizeAd_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RunAdAuction_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct JoinInterestGroup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LeaveInterestGroup_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LeaveInterestGroupForDocument_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UpdateAdInterestGroups_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DeprecatedGetURLFromURN_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DeprecatedReplaceInURN_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AdAuctionService() = default;


  using CreateAdRequestCallback = base::OnceCallback<void(const absl::optional<std::string>&)>;
  
  virtual void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) = 0;


  using FinalizeAdCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void FinalizeAd(const std::string& ads_guid, const ::blink::AuctionConfig& config, FinalizeAdCallback callback) = 0;


  using RunAdAuctionCallback = base::OnceCallback<void(bool, const absl::optional<::GURL>&)>;
  
  virtual void RunAdAuction(const ::blink::AuctionConfig& config, ::mojo::PendingReceiver<AbortableAdAuction> abort_receiver, RunAdAuctionCallback callback) = 0;


  using JoinInterestGroupCallback = base::OnceCallback<void(bool)>;
  
  virtual void JoinInterestGroup(const ::blink::InterestGroup& group, JoinInterestGroupCallback callback) = 0;


  using LeaveInterestGroupCallback = base::OnceCallback<void(bool)>;
  
  virtual void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name, LeaveInterestGroupCallback callback) = 0;

  
  virtual void LeaveInterestGroupForDocument() = 0;

  
  virtual void UpdateAdInterestGroups() = 0;


  using DeprecatedGetURLFromURNCallback = base::OnceCallback<void(const absl::optional<::GURL>&)>;
  
  virtual void DeprecatedGetURLFromURN(const ::GURL& uuid_url, DeprecatedGetURLFromURNCallback callback) = 0;


  using DeprecatedReplaceInURNCallback = base::OnceCallback<void()>;
  
  virtual void DeprecatedReplaceInURN(const ::GURL& uuid_url, std::vector<ReplacementPtr> replacements, DeprecatedReplaceInURNCallback callback) = 0;
};



class BLINK_COMMON_EXPORT AbortableAdAuctionProxy
    : public AbortableAdAuction {
 public:
  using InterfaceType = AbortableAdAuction;

  explicit AbortableAdAuctionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Abort() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT AdAuctionServiceProxy
    : public AdAuctionService {
 public:
  using InterfaceType = AdAuctionService;

  explicit AdAuctionServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateAdRequest(::blink::mojom::AdRequestConfigPtr config, CreateAdRequestCallback callback) final;
  
  void FinalizeAd(const std::string& ads_guid, const ::blink::AuctionConfig& config, FinalizeAdCallback callback) final;
  
  void RunAdAuction(const ::blink::AuctionConfig& config, ::mojo::PendingReceiver<AbortableAdAuction> abort_receiver, RunAdAuctionCallback callback) final;
  
  void JoinInterestGroup(const ::blink::InterestGroup& group, JoinInterestGroupCallback callback) final;
  
  void LeaveInterestGroup(const ::url::Origin& owner, const std::string& name, LeaveInterestGroupCallback callback) final;
  
  void LeaveInterestGroupForDocument() final;
  
  void UpdateAdInterestGroups() final;
  
  void DeprecatedGetURLFromURN(const ::GURL& uuid_url, DeprecatedGetURLFromURNCallback callback) final;
  
  void DeprecatedReplaceInURN(const ::GURL& uuid_url, std::vector<ReplacementPtr> replacements, DeprecatedReplaceInURNCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AbortableAdAuctionStubDispatch {
 public:
  static bool Accept(AbortableAdAuction* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AbortableAdAuction* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AbortableAdAuction>>
class AbortableAdAuctionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AbortableAdAuctionStub() = default;
  ~AbortableAdAuctionStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AbortableAdAuctionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AbortableAdAuctionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AdAuctionServiceStubDispatch {
 public:
  static bool Accept(AdAuctionService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AdAuctionService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AdAuctionService>>
class AdAuctionServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AdAuctionServiceStub() = default;
  ~AdAuctionServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AdAuctionServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AbortableAdAuctionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AdAuctionServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT AdAuctionServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT Replacement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Replacement, T>::value>;
  using DataView = ReplacementDataView;
  using Data_ = internal::Replacement_Data;

  template <typename... Args>
  static ReplacementPtr New(Args&&... args) {
    return ReplacementPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ReplacementPtr From(const U& u) {
    return mojo::TypeConverter<ReplacementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Replacement>::Convert(*this);
  }


  Replacement();

  Replacement(
      const std::string& match,
      const std::string& replacement);


  ~Replacement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ReplacementPtr>
  ReplacementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Replacement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, Replacement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Replacement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Replacement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Replacement_UnserializedMessageContext<
            UserType, Replacement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<Replacement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Replacement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Replacement_UnserializedMessageContext<
            UserType, Replacement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Replacement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string match;
  
  std::string replacement;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Replacement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Replacement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Replacement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Replacement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
ReplacementPtr Replacement::Clone() const {
  return New(
      mojo::Clone(match),
      mojo::Clone(replacement)
  );
}

template <typename T, Replacement::EnableIfSame<T>*>
bool Replacement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->match, other_struct.match))
    return false;
  if (!mojo::Equals(this->replacement, other_struct.replacement))
    return false;
  return true;
}

template <typename T, Replacement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.match < rhs.match)
    return true;
  if (rhs.match < lhs.match)
    return false;
  if (lhs.replacement < rhs.replacement)
    return true;
  if (rhs.replacement < lhs.replacement)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::Replacement::DataView,
                                         ::blink::mojom::ReplacementPtr> {
  static bool IsNull(const ::blink::mojom::ReplacementPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::ReplacementPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::Replacement::match)& match(
      const ::blink::mojom::ReplacementPtr& input) {
    return input->match;
  }

  static const decltype(::blink::mojom::Replacement::replacement)& replacement(
      const ::blink::mojom::ReplacementPtr& input) {
    return input->replacement;
  }

  static bool Read(::blink::mojom::Replacement::DataView input, ::blink::mojom::ReplacementPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_INTEREST_GROUP_AD_AUCTION_SERVICE_MOJOM_H_